//Name: Rishi     Student Number: 707580
//Purpose: To detect temperature and humidity

//libraries for humiture sensor and LCD
#include <dht.h>
#include <LiquidCrystal_I2C.h>
#include <Wire.h> 

// set the LCD address to 0x27 for a 16 chars and 2 line display
LiquidCrystal_I2C lcd(0x27,16,2);

//create a variable type of dht
dht DHT;

//Humiture sensor connected to pin 7
const int DHT11_PIN = 7;

//declare variables for leds
int redLed=3;
int greenLed=5;
int blueLed=6;


void setup()
{
  Serial.begin(9600); //initialize the serial monitor
  lcd.init();  //initialize the lcd
  lcd.backlight();  //turn on the backlight 

  //declare leds as outputs
  pinMode(redLed,OUTPUT);
  pinMode(greenLed,OUTPUT);
  pinMode(blueLed, OUTPUT);
}


void displayTemp()
{
  // DISPLAY DATA
  lcd.setCursor(0, 0);
  lcd.print("Tem:");
  
  lcd.setCursor(5, 0);
   
  lcd.print(DHT.temperature,1); //print the temperature on lcd
  lcd.print(char(223)); //print the unit ℃ 
  lcd.print("C");
   
  lcd.setCursor(0, 1);
  
  lcd.print("Hum:");
  lcd.print(DHT.humidity,1); //print the humidity on lcd
  lcd.print(" %"); 
  delay(200); //wait a while 
}


void led()
{
  if(DHT.temperature>=25)
  {
    for (int i =0; i<256; i++)
    {
      analogWrite(redLed, i);
      delay(10);
    }

    for (int i  = 255; i>=0; i--)
    {
      analogWrite(redLed,i);
      delay(10);
    }

    Serial.println("Temperature Exceeded 25℃");
  }
  else if (DHT.temperature<=20)
  {
    for (int i =0; i<256; i++)
    {
      analogWrite(greenLed,i);
      delay(10);
    }

    for (int i  = 255; i>=0; i--)
    {
      analogWrite(greenLed,i);
      delay(10);
    }
    
    Serial.println("Temperature below 20℃");
  }
  else if ((DHT.temperature>15) && (DHT.temperature<25))
  {
    for (int i =0; i<256; i++)
    {
      analogWrite(greenLed,i);
      delay(10);
    }

    for (int i  = 255; i>=0; i--)
    {
      analogWrite(greenLed,i);
      delay(10);
    }
    
    Serial.println("Temperature stable");
  }
}

void loop()
{
  //read data

  //read the value returned from the sensor
  int chk = DHT.read11(DHT11_PIN);
  switch (chk)
  {
  case DHTLIB_OK:  
    Serial.println("OK!"); 
    break;
    
  case DHTLIB_ERROR_CHECKSUM: 
    Serial.print("Checksum error,\t"); 
    break;
    
  case DHTLIB_ERROR_TIMEOUT: 
    Serial.print("Time out error,\t"); 
    break;
    
  default: 
    Serial.print("Unknown error,\t"); 
    break;
  }
  
  displayTemp();
  led();
}

